/* load external module 'Preferences.js' into the scope of 'foxfm
   --> prefix 'foxfm.' need to be used at function calls of this module */
var foxfm = {};
Components.utils.import("resource://modules/Preferences.js", foxfm);

/*******************************/
/* Initialise global variables */

/* global variables for preference handling */
var prefBranchOFMStrengthLevel = new foxfm.Preferences("foxfm.pref.ofm.strengthlevel.");
var prefBranchAbout = new foxfm.Preferences("foxfm.pref.about.");
var prefBranchOFMFunctionSettings = new foxfm.Preferences("foxfm.pref.ofm.");

/* global variable saving OFM strength level points */
var strengthPoints=new Array();

/* global variable saving OFM strength level points */
var teamName;

/*******************************/
/* Functions                   */

function foxfm_getMaxOFMTeamName()
{
	try
	{
		return(prefBranchOFMFunctionSettings.get("team"));
	}
	catch(e)
	{
		exceptionHandler(e);
	}		
}

function foxfm_getMaxOFMStrengthLevel()
{
	try
	{
		return(prefBranchOFMStrengthLevel.get("maxlevel"));
	}
	catch(e)
	{
		exceptionHandler(e);
	}		
}

function foxfm_getOFMStrengthLevel()
{
	try
	{
		var maxOFMLevel=foxfm_getMaxOFMStrengthLevel();
		var aStrengthLevel = new Array(maxOFMLevel);
		var prefLvlStr="";
		for(i=0; i<maxOFMLevel; i++)
		{
			aStrengthLevel[i] = prefBranchOFMStrengthLevel.get(i+1);
		}
		// alertArray(aStrengthLevel);
		return aStrengthLevel;
	}
	catch(e)
	{
		exceptionHandler(e);
	}		
}

function foxfm_addJavaScript(doc, js) 
{    
	var head = doc.getElementsByTagName("head")[0]; 
	var script = doc.createElement("script");
	script.type = "text/javascript";
	script.src = js;
	head.appendChild(script);
	return script;
}

function foxfmdebug(exception) {
	window.openDialog(
        "chrome://foxfm/content/resources/html/showErrorBacktrace.htm",
        "errorbacktrace",
        "centerscreen=yes,chrome=yes,modal=yes,resizable=yes",
        exception,
        "display error"
      ); 
}

function exceptionHandler(err)
{
	var vDebug = "";
    for (var prop in err)
    { 
       vDebug += "property: "+ prop+ " value: ["+ err[prop]+ "]\n";
    }
    vDebug += "toString(): " + " value: [" + err.toString() + "]";
    alert(vDebug);
}

function scanTableByRegExp (table, str)
{
	// alert("foxfm: scanTableByRegExp()");
	var tableCell	= new Array();
	var rows		= table.rows;
	var k			= 0;
	// go through the rows
	for(var i=0; i<rows.length; i++)
	{
		cells = rows[i].cells;
		// go through the cells
		for(var j=0; j<cells.length; j++)
		{
			// alert(cells[j].innerHTML);
			if(cells[j].innerHTML.match(str))
			{
				// alert(cells[j].innerHTML);
				tableCell[k]			= new Object();
				tableCell[k]["row"]		= i;
				tableCell[k]["cell"]	= j;
				k++;	
			}
		}
	}
	return tableCell;
}

function scanTableByRegExp2 (table, str)
{
	// alert("foxfm: scanTableByRegExp2()");
	var tableCell	= new Array();
	var rows		= table.rows;
	var k			= 0;
	// go through the rows
	for(var i=0; i<rows.length; i++)
	{
		cells = rows[i].cells;
		// go through the cells
		for(var j=0; j<cells.length; j++)
		{
			// alert(cells[j].innerHTML);
			if(cells[j].innerHTML.match(str))
			{
				// alert(cells[j].innerHTML);
				tableCell[k]			= new Object();
				tableCell[k]["row"]		= i;
				tableCell[k]["cell"]	= j;
				k++;	
			}
		}
	}
	return tableCell;
}

function searchTable (table, lookFor1st, lookFor2nd)
{	
	// alert("foxfm: searchTable()");
	var tableCell = new Array();
	//alert(lookFor1st + " " + lookFor2nd);
	var rows = table.rows;
	// go through the rows
	for(var i=0; i<rows.length; i++)
	{
		cells = rows[i].cells;
		// go through the cells
		for(var j=0; j<cells.length; j++)
		{
			//alert(cells[j].innerHTML);
			cell = cells[j];
			if(cell.innerHTML.match(lookFor1st))
			{
				// alert(cell.innerHTML);	
				nextIndex = j+1;
				if(nextIndex<cells.length) 
				{
					if(cells[nextIndex].innerHTML.match(lookFor2nd)) 
					{
						// tableCell[k]= new Object();
						//alert(cell.innerHTML);
						//alert("HIT: '" + lookFor1st + "' and '" + lookFor2nd + "' in row " + i);
						// return the row where the string was found
						tableCell[0] = i;
						tableCell[1] = j;
						return tableCell;
					}
				}	
			}
		}
	}
	return tableCell;
}

function findTable(arrayTable, strFirst, strSecond)
{
	for(var i=0; i<arrayTable.length; i++)
	{
		// get table of team --> look for "Pos" and "Spielername"
		var tableCell = searchTable(arrayTable[i], strFirst, strSecond);
		var rowIndex = tableCell[0];
		var colIndex = tableCell[1];
		// found table?
		if(rowIndex>=0)
		{
			// return index of found table
			return i;
		}
	}
	return -1;
}

// Try to find the row of the GIVEN table which contains the GIVEN
// two strings in adjacent cells and RETURN the row.
function findRow(table, strFirst, strSecond)
{
	// alert("foxfm: searchTable()");
	//alert(strFirst + " " + strSecond);
	var rows = table.rows;
	// iterate through the rows
	for(var j=0; j<rows.length; j++)
	{
		// get cells of current row
		cells = rows[j].cells;
		// iterate through the cells
		for(var k=0; k<cells.length; k++)
		{
			//alert(cells[k].innerHTML);
			cell = cells[k];
			// check if the content is first search string 'strFirst'
			if(cell.innerHTML.match(strFirst))
			{
				//alert(cell.innerHTML);	
				nextIndex = k+1;
				// check if next cell in row contains second search string 'strSecond'
				// --> found row
				if(nextIndex<cells.length) 
				{
					if(cells[nextIndex].innerHTML.match(strSecond)) 
					{
						//alert(cell.innerHTML);
						//alert("HIT: '" + lookFor1st + "' and '" + strSecond + "' in row " + j);
						// return the row where the string was found
						return j;
					}
				}	
			}
		}
	}
	// nothing was found
	return -1;
}

// Try to find the column of the GIVEN table-row which contains the GIVEN
// string and RETURN the column.
function findColumn(row, str)
{
	// alert("foxfm: searchTable()");
	// alert(row.length);
	// iterate through the rows
	for(var i=0; i<row.length; i++)
	{
		// alert(row[i].innerHTML);	
		// check if the cell in the given row contains the search string 'str'
		// --> found column
		if(row[i].innerHTML.match(str))
		{
			// alert("HIT: '" + str + "' in column " + i);
			// return the column where the string was found
			return i;
		}
	}
	// nothing was found
	return -1;
}

function addCell(tbl, row, col, content, styleClass, styleAlign, styleBgColor, attrWidth)
{
	try 
	{
		var newCell = tbl.rows[row].insertCell(col);
		newCell.innerHTML = content;
		if(styleClass != "") 
		{
			newCell.className = styleClass;
		}
		newCell.align = styleAlign;
		newCell.style.backgroundColor = styleBgColor;
		if(attrWidth)
		{
			newCell.setAttribute("width", attrWidth);
		}
	} catch(e) {
		exceptionHandler(e);
	}
}

function tableChangeAttributes(tbl, width)
{
	tbl.width =width;
}

function getNumberFromCell(cell)
{
	try
	{
		// alert("getNumberFromHtmlString(): cell.innerHTML: " + cell.innerHTML);
		if(cell)
		{
			num = getNumberFromString(cell.innerHTML);
		}
		else
		{
			return NaN;
		}		

		if(isNaN(num))
		{
			try 
			{
				// alert("try to get number from HTML: " + cell.getElementsByTagName("b")[0].innerHTML);
				num = getNumberFromString(cell.getElementsByTagName("b")[0].innerHTML);				
			} catch(e) {
				try
				{
					// alert("try to get number from HTML: " + cell.getElementsByTagName("strong")[0].innerHTML);
					num = getNumberFromString(cell.getElementsByTagName("strong")[0].innerHTML);					
				} catch(e) {					
					try
					{
						// alert("try to get number from HTML: " + cell.getElementsByTagName("font")[0].innerHTML);
						num = getNumberFromString(cell.getElementsByTagName("font")[0].innerHTML);
					} catch(e) {
						try
						{
							// alert("try to get number from HTML: " + cell.getElementsByTagName("div")[0].innerHTML);
							num = getNumberFromString(cell.getElementsByTagName("div")[0].innerHTML);
						} catch(e) {
							try
							{
								// alert("try to get number from HTML: " + cell.getElementsByTagName("a")[0].innerHTML);
								num = getNumberFromString(cell.getElementsByTagName("a")[0].innerHTML);
							} catch(e) {
								alert("Could not get the value from the HTML string: " + num);
							}
						}
					}
				}
			}
		} 
		// alert("getNumberFromHtmlString(): return(" + num +")");
		return num;
	} catch(e) {
		exceptionHandler(e);
	}
}

function getNumberFromString (str)
{
	try
	{
		// alert(str + ": " + parseFloat(str.replace(".","")));
		return parseFloat(str.replace(".",""));
	} catch(e) {
		exceptionHandler(e);
	}
}

function getAWP(ep, tp)
{
	return new Number(Math.round(((2*ep*tp)/(ep + tp))));
}

function getAWPs(eps, tps)
{
	var awps = new Array(eps.length);
	for(var i=0; i<eps.length; i++)
	{
		awps[i] = getAWP(eps[i], tps[i]);
	}
	return awps;
}

function getStrengthLevel(awps)
{
	// alertArray(strengthPoints);
	// alert(awps);
	for(var i=0; i<strengthPoints.length; i++)
	{
		// alert(awps + " < " + getNumberFromString(strengthPoints[i]));
		if(awps<getNumberFromString(strengthPoints[i]))
		{
			// alert("getStrengthLevel(): return( " + i + " );");
			return i;
		}
	}
	return -1;
}

function getAWPsOfLevel(level)
{
	if(level>0)
	{
		return getNumberFromString(strengthPoints[level-1]);
	}
	return -1;
}

function addColCurrentStrength()
{
}

function addColCurrentAWPs(tbl, rowIndex, colIndex, awps)
{
	//alert(rowIndex);
	//alert(tbl.rows[rowIndex].cells[0].innerHtml);
	addCell(tbl, rowIndex, colIndex, "<a class=\"info\">AWPs<span>AWPs des Spielers</span></a>", "top", "center", "", "");
	for(var i=rowIndex+1; i<tbl.rows.length; i++) 
	{
		//alert(tbl.rows.length);
		addCell(tbl, i, colIndex, awps[i].toString(10), "", "center", "", "");
	}	
}

function addCurrLvlAwpsDiffNextLvl(playerTable, headerRow, ignoreRow, lvlCol, epCol, tpCol, awpCol, newColCurrLvl, newColAwpDiff, newColNextLvl)
{
	// alert("foxfm::addCurrLvlAwpsDiffNextLvl: newColNextLvl - " + newColNextLvl);
	if(newColCurrLvl)
	{
		addCell(playerTable, headerRow, newColCurrLvl, "<p align=center><a class=\"info\">Aktuelle<br>St&auml;rke<span>St&auml;ke des Spielers</span></a></p>", "top", "center", "", "");
	}
	if(newColAwpDiff)
	{
		addCell(playerTable, headerRow, newColAwpDiff, "<p align=center><a class=\"info\">AWPs<br>Diff<span>Differenz zur n&auml;chsten St&auml;rkestufe</span></a></p>", "top", "center", "", "");				
	}
	if(newColNextLvl)
	{
		addCell(playerTable, headerRow, newColNextLvl, "<p align=center><a class=\"info\">N&auml;chste<br>St&auml;rke<span>Die n&auml;chsten St&auml;rkestufe</span></a></p>", "top", "center", "", "");
	}
	var awp=NaN, tp=NaN, ep=NaN;

	for(var j=headerRow+1; j<playerTable.rows.length; j++)
	// for(var j=headerRow+1; j<headerRow+2; j++) // for debugging: only run throught the first row
	{		
		// alert(playerTable.rows[j].cells[awpCol].innerHTML);
		try
		{		
			if(j != ignoreRow)
			{
				// get the awp of the player - either from the given column or calculate it from TPs and EPs
				if(awpCol)
				{
					awp = getNumberFromCell(playerTable.rows[j].cells[awpCol]);
				} else {
					ep = getNumberFromCell(playerTable.rows[j].cells[epCol]);
					tp = getNumberFromCell(playerTable.rows[j].cells[tpCol]);
					awp = getAWP(ep, tp);
				}
				
				if(!isNaN(awp))
				{		
					var newCurrLvl = getStrengthLevel(awp);
					var currLvl = getNumberFromCell(playerTable.rows[j].cells[lvlCol]);
					var diffLvl = newCurrLvl - currLvl;
					// alert("addCurrLvlAwpsDiffNextLvl(): TP: " + tp + "; EP: " + ep + "; AWP: " + awp + "; CurrLvl: " + currLvl + "; new CurrentLvl: " + newCurrLvl);
					addCell(playerTable, j, newColCurrLvl, newCurrLvl + "(" + diffLvl + ")", "", "right", "", 50);
					addCell(playerTable, j, newColAwpDiff, awp - getAWPsOfLevel(newCurrLvl+1), "", "right", "", 70);
					if(newColNextLvl)
					{
						addCell(playerTable, j, newColNextLvl, (newCurrLvl+1) + " (" + getAWPsOfLevel(newCurrLvl+1) + ")", "", "right", "", 70);
					}				
				} else {
					// This case was added for the last line in the table "Team". Otherwise no new columns would be added there!
					addCell(playerTable, j, newColCurrLvl, "", "", "right", "#49a084", "");
					addCell(playerTable, j, newColAwpDiff, "", "", "right", "#49a084", "");
					addCell(playerTable, j, newColNextLvl, "", "", "right", "#49a084", "");
				}
			}
		} catch (e) {			
			exceptionHandler(e);
		}
	}	
}

function getXMLDocument( ajax )
{
	if (typeof DOMParser == "undefined") {
		DOMParser = function(){};

		DOMParser.prototype.parseFromString = function(str, contentType)
		{
			if (typeof ActiveXObject != "undefined") 
			{
				var doc = new ActiveXObject("MSXML.DomDocument");
				doc.loadXML(str);
				// alert("ActiveX");
				return doc;
			} else if ( typeof XMLHttpRequest != "undefined" ) 
			{
				var req = new XMLHttpRequest();
				req.open("GET", "data:" + (contentType || "application/xml") + ";charset=utf-8," + encodeURIComponent(str), false);
				if ( req.overrideMimeType )
					req.overrideMimeType(contentType);
				req.send(null);
				// alert(req.responseXML);
				return req.responseXML;
			} else
				throw new FatalException( "Can't find a valid xml parser", "AJAX::getXMLDocument()" );
		}
	}
	var strDocument = ajax.responseText;
	var xmlDocument = ajax.responseXML;
	try {
		if( ! xmlDocument || xmlDocument.childNodes.length === 0 )
			xmlDocument = (new DOMParser()).parseFromString( strDocument, "application/xml" );
		// alert(xmlDocument);
		return xmlDocument;
	} catch( e ) {
		return null;
	}
} 

// function HTMLParser(aHTMLString){
   // var parseDOM = content.document.createElement('div');
   // parseDOM.appendChild(Components.classes["@mozilla.org/feed-unescapehtml;1"]
      // .getService(Components.interfaces.nsIScriptableUnescapeHTML)
      // .parseFragment(aHTMLString, false, null, parseDOM));
   // return parseDOM;
// }

// // Components.utils.reportError("asdf");



// var xmlHttpObject = new XMLHttpRequest();
// function handleStateChange()
// {
	// // Derzeitigen Status zurckgeben
	// if(xmlHttpObject.readyState == 4)
	// {
		// var oDom = HTMLParser(xmlHttpObject.responseText);
		// var tables = oDom.getElementsByTagName("table");
		// // alert(table.length);
	
		// // var doc = getXMLDocument(xmlHttpObject);
		// // // Components.utils.reportError(xmlHttpObject.responseText);
		// // var tbl = doc.getElementsByTagName("table");
		// // // alert(tbl.length);
		// // var oIframe = doc.getElementsByTagName("iframe");
		// // if(oIframe)
		// // {
			// // if(oIframe.contentWindow)
				// // alert("got iframe.contentWindow: " + oIframe.contentWindow);
			// // if(oIframe.contentDocument)
				// // alert("got iframe.contentDocument: " + oIframe.contentDocument);
		// // }
 		// // var oDoc = (oIframe.contentWindow || oIframe.contentDocument);
 		// // alert(oDoc);
		// // alert(oIframe[0].innerHTML);
		// // var tblNo = findTable(table, "Strke", "0");
		// // get the cells of the current table containing the search string 
		// // alertArray(strengthPoints);
		// var result = findTableByRegExp(tables, "Strke <a>[0-9]{1,2}");
		// // alert("found " + result.length + " tables");
		// for(var i=0; i<result.length; i++)
		// {
			// var strength = getNumberFromCell(tables[result[i]["table"]].rows[result[i]["row"]].cells[result[i]["cell"]]);
			// var strengthPoint = getNumberFromCell(tables[result[i]["table"]].rows[result[i]["row"]].cells[result[i]["cell"]+1]);
			// strengthPoints[strength-1] = strengthPoint;
			// // alert("table: " + result[i]["table"] + " row: " + result[i]["row"] + " col: " + result[i]["cell"] + " : " + tables[result[i]["table"]].rows[result[i]["row"]].cells[result[i]["cell"]].innerHTML);
			// // alert("Strength: " + strength + " AWPs: " + strengthPoint);
		// }
		// // alertArray(strengthPoints);
		// // alert( doc.getElementsByTagName("td")[0].innerHTML );
		// // Components.utils.reportError(xmlHttpObject.responseText.documentElement.getElementsByTagName("table"));
	// }
	// // alert("xmlHttpObject.readyState = " + xmlHttpObject.readyState + (xmlHttpObject.readyState == 4 ? " HTTP-Status = " + xmlHttpObject.status : ''));
// }
// // get the content of the iframe of the AWP page 'http://www.sc-lichteneiche.de/forum/ofm-awp-rechner.php'
// xmlHttpObject.open('GET', 'http://www.sc-lichteneiche.de/forum/ofm-awp-rechner-calc.php');
// // xmlHttpObject.open('GET', 'http://www.sc-lichteneiche.de/forum/ofm-awp-rechner.php');
// // Handler hinterlegen
// xmlHttpObject.onreadystatechange = handleStateChange;
// // Anfrage abschicken
// xmlHttpObject.send(null);

// var theString='<a id="a"><b id="b">hey!</b></a>';
// var parser = new DOMParser();
// alert(xmlHttpObject.responseText);
// var dom = parser.parseFromString(xmlHttpObject.responseText, "text/xml");
// // print the name of the root element or error message
// alert(dom.documentElement.nodeName == "parsererror" ? "error while parsing" : dom.documentElement.nodeName);

function alertArray(array)
{
	var string = "";
	for(var i=0; i<array.length; i++)
	{
		// alert(array[i] + ": " + parseFloat(array[i].replace(".","")));
		string += i + ": " + array[i] + "\n";
	}
	alert(string);
}